/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package org.uytube.ui.categoria;

import java.awt.Color;
import javax.swing.*;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;
import org.uytube.controladores.Fabrica;
import org.uytube.controladores.ICategoria;
import org.uytube.ui.PopUp;

/** @author toto */
public class AltaCategoria extends javax.swing.JInternalFrame {

  private final ICategoria iCategoria = Fabrica.getControllerOf(Fabrica.Controller.CATEOGRIA);

  private void disableButton(JButton button) {
    button.setEnabled(false);
    button.setBackground(Color.GRAY);
  }

  /** Creates new form AltaLista */
  public AltaCategoria() {
    initComponents();
    disableButton(btnAceptar);
    txtNombreLista
        .getDocument()
        .addDocumentListener(
            new DocumentListener() {
              @Override
              public void insertUpdate(DocumentEvent arg0) {
                update();
              }

              @Override
              public void removeUpdate(DocumentEvent arg0) {
                update();
              }

              @Override
              public void changedUpdate(DocumentEvent arg0) {
                update();
              }

              private void update() {
                if (txtNombreLista.getText().isEmpty()) {
                  disableButton(btnAceptar);
                } else {
                  btnAceptar.setEnabled(true);
                  btnAceptar.setBackground(new Color(0, 123, 64));
                }
              }
            });
  }

  /**
   * This method is called from within the constructor to initialize the form. WARNING: Do NOT
   * modify this code. The content of this method is always regenerated by the Form Editor.
   */
  @SuppressWarnings("unchecked")
  // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
  private void initComponents() {

    jPanel3 = new javax.swing.JPanel();
    lblTitle = new javax.swing.JLabel();
    panelCategoria = new javax.swing.JPanel();
    jSeparator6 = new javax.swing.JSeparator();
    jSeparator7 = new javax.swing.JSeparator();
    jLabel4 = new javax.swing.JLabel();
    btnCancelar = new javax.swing.JButton();
    btnAceptar = new javax.swing.JButton();
    txtNombreLista = new javax.swing.JTextField();
    jLabel9 = new javax.swing.JLabel();
    jLabel8 = new javax.swing.JLabel();
    jLabel1 = new javax.swing.JLabel();

    setBorder(null);
    setClosable(true);
    setIconifiable(true);
    setTitle("Alta Categoria");
    setMinimumSize(new java.awt.Dimension(439, 437));
    setPreferredSize(new java.awt.Dimension(439, 437));
    getContentPane().setLayout(null);

    jPanel3.setBackground(new java.awt.Color(246, 246, 246));
    jPanel3.setLayout(null);

    lblTitle.setFont(new java.awt.Font("Monospaced", 0, 24)); // NOI18N
    lblTitle.setForeground(new java.awt.Color(53, 12, 87));
    lblTitle.setHorizontalAlignment(javax.swing.SwingConstants.CENTER);
    lblTitle.setText("Alta Categoria");
    jPanel3.add(lblTitle);
    lblTitle.setBounds(0, 20, 440, 29);

    panelCategoria.setBackground(new java.awt.Color(255, 255, 255));
    panelCategoria.setBorder(
        javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    panelCategoria.setLayout(null);
    panelCategoria.add(jSeparator6);
    jSeparator6.setBounds(30, 50, 290, 10);
    panelCategoria.add(jSeparator7);
    jSeparator7.setBounds(50, 120, 150, 20);

    jLabel4.setFont(new java.awt.Font("Monospaced", 1, 14)); // NOI18N
    jLabel4.setForeground(new java.awt.Color(33, 33, 33));
    jLabel4.setText("Datos de Categoria");
    panelCategoria.add(jLabel4);
    jLabel4.setBounds(30, 30, 210, 17);

    btnCancelar.setBackground(new java.awt.Color(255, 50, 40));
    btnCancelar.setFont(new java.awt.Font("Monospaced", 0, 14)); // NOI18N
    btnCancelar.setForeground(new java.awt.Color(255, 255, 255));
    btnCancelar.setText("Cancelar");
    btnCancelar.setBorder(
        javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    btnCancelar.setContentAreaFilled(false);
    btnCancelar.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
    btnCancelar.setOpaque(true);
    btnCancelar.addMouseListener(
        new java.awt.event.MouseAdapter() {
          public void mouseClicked(java.awt.event.MouseEvent evt) {
            btnCancelarMouseClicked(evt);
          }
        });
    panelCategoria.add(btnCancelar);
    btnCancelar.setBounds(190, 170, 110, 40);

    btnAceptar.setBackground(new java.awt.Color(0, 123, 64));
    btnAceptar.setFont(new java.awt.Font("Monospaced", 0, 14)); // NOI18N
    btnAceptar.setForeground(new java.awt.Color(255, 255, 255));
    btnAceptar.setText("Aceptar");
    btnAceptar.setBorder(
        javax.swing.BorderFactory.createBevelBorder(javax.swing.border.BevelBorder.RAISED));
    btnAceptar.setContentAreaFilled(false);
    btnAceptar.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
    btnAceptar.setEnabled(false);
    btnAceptar.setOpaque(true);
    btnAceptar.addMouseListener(
        new java.awt.event.MouseAdapter() {
          public void mouseClicked(java.awt.event.MouseEvent evt) {
            btnAceptarMouseClicked(evt);
          }
        });
    panelCategoria.add(btnAceptar);
    btnAceptar.setBounds(50, 170, 110, 40);

    txtNombreLista.setForeground(new java.awt.Color(60, 63, 65));
    txtNombreLista.setBorder(
        javax.swing.BorderFactory.createTitledBorder(
            javax.swing.BorderFactory.createEmptyBorder(1, 1, 1, 1),
            "Nombre * ",
            javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION,
            javax.swing.border.TitledBorder.DEFAULT_POSITION,
            new java.awt.Font("Monospaced", 0, 12))); // NOI18N
    panelCategoria.add(txtNombreLista);
    txtNombreLista.setBounds(50, 84, 150, 37);

    jPanel3.add(panelCategoria);
    panelCategoria.setBounds(40, 70, 350, 230);

    jLabel9.setIcon(
        new javax.swing.ImageIcon(getClass().getResource("/images/logo.png"))); // NOI18N
    jPanel3.add(jLabel9);
    jLabel9.setBounds(350, 306, 30, 30);

    jLabel8.setFont(new java.awt.Font("Monospaced", 1, 12)); // NOI18N
    jLabel8.setForeground(new java.awt.Color(255, 255, 255));
    jLabel8.setText("UyTube");
    jPanel3.add(jLabel8);
    jLabel8.setBounds(378, 310, 50, 30);

    jLabel1.setIcon(
        new javax.swing.ImageIcon(getClass().getResource("/images/formBackground.jpg"))); // NOI18N
    jPanel3.add(jLabel1);
    jLabel1.setBounds(130, 110, 310, 240);

    getContentPane().add(jPanel3);
    jPanel3.setBounds(0, 0, 440, 350);

    setBounds(282, 204, 439, 370);
  } // </editor-fold>//GEN-END:initComponents

  private void btnAceptarMouseClicked(
      java.awt.event.MouseEvent evt) { // GEN-FIRST:event_btnAceptarMouseClicked
    if (btnAceptar.isEnabled()) {
      JFrame frame = (JFrame) getDesktopPane().getTopLevelAncestor();
      try {
        iCategoria.altaCategoria(txtNombreLista.getText());
        this.dispose();
        new PopUp(frame, "Alta Categoria", "Se creo la Categoria", 5, PopUp.LEVEL.SUCCESS);
      } catch (IllegalArgumentException e) {
        new PopUp(frame, "Alta Categoria", e.getMessage(), 5, PopUp.LEVEL.ERROR);
      }
    }
  } // GEN-LAST:event_btnAceptarMouseClicked

  private void btnCancelarMouseClicked(
      java.awt.event.MouseEvent evt) { // GEN-FIRST:event_btnCancelarMouseClicked
    dispose();
  } // GEN-LAST:event_btnCancelarMouseClicked

  // Variables declaration - do not modify//GEN-BEGIN:variables
  private javax.swing.JButton btnAceptar;
  private javax.swing.JButton btnCancelar;
  private javax.swing.JLabel jLabel1;
  private javax.swing.JLabel jLabel4;
  private javax.swing.JLabel jLabel8;
  private javax.swing.JLabel jLabel9;
  private javax.swing.JPanel jPanel3;
  private javax.swing.JSeparator jSeparator6;
  private javax.swing.JSeparator jSeparator7;
  private javax.swing.JLabel lblTitle;
  private javax.swing.JPanel panelCategoria;
  private javax.swing.JTextField txtNombreLista;
  // End of variables declaration//GEN-END:variables
}
